//+------------------------------------------------------------------+
//|                                                   Robot Danu.mq4 |
//|                      danusaputra  2012, Ultimate Explorer Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "danusaputra  2012, Ultimate Explorer Corp."
#property link      "http://www.metaquotes.net"

#define MAGICMA  20050610

#include <stdlib.mqh>

extern double lStopLoss          = 50;
extern double sStopLoss          = 50;
extern double lTakeProfit        = 100;
extern double sTakeProfit        = 100;
extern double lTrailingStop      = 10;
extern double sTrailingStop      = 10;
extern double Lots               = 0.5;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern int    Slippage           = 3;
extern double Period1            = 28;
extern double Period2            = 56;
extern double Period3            = 112;
extern string Dev_Step_1         ="3,9";
extern string Dev_Step_2         ="24,15";
extern string Dev_Step_3         ="63,36";
extern int    Symbol_1_Kod       =140;
extern int    Symbol_2_Kod       =141;
extern int    Symbol_3_Kod       =142;
extern bool   ShowAlerts         = false;

double pipMultiplier = 1;

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<10) lot=10;
   return(lot);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ZZ_1, ZZ_2;
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();

//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
   

//---- get 3 Level ZZ Semafor
   
   ZZ_1=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,5,3);
   ZZ_2=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,4,3);
   

//---- sell conditions
   
   if(ZZ_1 > ZZ_2 && OP_SELL <= 3)  
   {
     int res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,"Robot Danu",MAGICMA,0,Red);
      
   return;
   }
     
//---- buy conditions
   if(ZZ_1 < ZZ_2 && OP_BUY <= 3)  
   {
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,"Robot Danu",MAGICMA,0,Blue);
      
   return;
   }

//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ZZ_1, ZZ_2;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ZZ_1=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,5,3);
   ZZ_2=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,4,3);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(ZZ_1 > ZZ_2) OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*pipMultiplier,White);
         break;
        }
            
      if(OrderType()==OP_SELL)
        {
         if(ZZ_1 < ZZ_2) OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*pipMultiplier,White);
         break;
        }
        
     }
//----
  }
  
//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICMA) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() < Bid - trailingStop * Point * pipMultiplier) 
                      ModifyStopLoss(Bid    - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICMA) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(Symbol(),MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
{
    
    if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1; 
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
   
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
//----
  }
//+------------------------------------------------------------------+